diff -r da501b86b720 erts/emulator/beam/bif.c
--- a/erts/emulator/beam/bif.c	Tue Dec 13 03:24:59 2005
+++ b/erts/emulator/beam/bif.c	Mon Dec 12 22:30:27 2005
@@ -3823,3 +3823,49 @@
     }
     BIF_RET(ret);
 }
+
+/**********************************************************************/
+
+/* find a series of characters in a binary */
+
+BIF_RETTYPE strstr_binary_2(BIF_ALIST_2)
+{
+    Eterm big = BIF_ARG_1;
+    Eterm little = BIF_ARG_2;
+
+    if (is_binary(big) && is_binary(little)) {
+
+        byte* big_ptr = 0;
+        int big_len = binary_size(big);
+
+        byte* little_ptr = 0;
+        int little_len = binary_size(little);
+
+        byte* cur;
+        byte* max_big; 
+        char  first_little;
+        int   index = -1;
+
+        /* Grab pointers into the binary objects */
+        GET_BINARY_BYTES(big, big_ptr);
+        GET_BINARY_BYTES(little, little_ptr);
+
+        /* Initialize for our search */
+        max_big = (big_ptr + big_len) - little_len; 
+        first_little = *little_ptr;
+
+        /* Loop over each byte in big, doing a memcmp() IIF the first
+           character matches the first char in little AND the length
+           remaining in big is <= to number of bytes in little */
+        for (cur = big_ptr; cur <= max_big; cur++) {
+            if (*cur == first_little && memcmp(cur, little_ptr, little_len) == 0) {
+                index = (long)cur - (long)big_ptr;
+                break;
+            }
+        }
+
+        BIF_RET(make_small(index));
+    } else {
+	BIF_ERROR(BIF_P, BADARG);
+    }
+}
diff -r da501b86b720 erts/emulator/beam/bif.tab
--- a/erts/emulator/beam/bif.tab	Tue Dec 13 03:24:59 2005
+++ b/erts/emulator/beam/bif.tab	Mon Dec 12 22:30:27 2005
@@ -656,3 +656,5 @@
 #
 #bif erlang:concat_binary/1
 #bif erlang:info/1
+
+bif erlang:strstr_binary/2
